VTK: vtkVoronoiKernel Class Reference

| VTK 9.3.1

Public Member Functions | Protected Member Functions | List of all members
vtkVoronoiKernel Class Reference

a Voronoi interpolation kernel More...

`#include <vtkVoronoiKernel.h>`

Inheritance diagram for vtkVoronoiKernel:
[legend]
Collaboration diagram for vtkVoronoiKernel:
[legend]

## Public Member Functions
vtkIdType | ComputeBasis (double x[3], vtkIdList *pIds, vtkIdType ptId=0) override
| Given a point x (and optional associated ptId), determine the points around x which form an interpolation basis. More...
vtkIdType | ComputeWeights (double x[3], vtkIdList *pIds, vtkDoubleArray *weights) override
| Given a point x, and a list of basis points pIds, compute interpolation weights associated with these basis points. More...
Public Member Functions inherited from vtkInterpolationKernel
virtual void | Initialize (vtkAbstractPointLocator *loc, vtkDataSet *ds, vtkPointData *pd)
| Initialize the kernel. More...
| vtkAbstractTypeMacro (vtkInterpolationKernel, vtkObject)
| Standard method for type and printing. More...
virtual void | SetRequiresInitialization (bool)
| Indicate whether the kernel needs initialization. More...
virtual bool | GetRequiresInitialization ()
| Indicate whether the kernel needs initialization. More...
virtual void | RequiresInitializationOn ()
| Indicate whether the kernel needs initialization. More...
virtual void | RequiresInitializationOff ()
| Indicate whether the kernel needs initialization. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Protected Member Functions
| vtkVoronoiKernel ()
| ~vtkVoronoiKernel () override
Protected Member Functions inherited from vtkInterpolationKernel
| vtkInterpolationKernel ()
| ~vtkInterpolationKernel () override
virtual void | FreeStructures ()
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)
typedef vtkInterpolationKernel | Superclass
| Standard methods for instantiation, obtaining type information, and printing. More...
static vtkVoronoiKernel * | New ()
| Standard methods for instantiation, obtaining type information, and printing. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instantiation, obtaining type information, and printing. More...
static vtkVoronoiKernel * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instantiation, obtaining type information, and printing. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instantiation, obtaining type information, and printing. More...
vtkVoronoiKernel * | NewInstance () const
| Standard methods for instantiation, obtaining type information, and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instantiation, obtaining type information, and printing. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instantiation, obtaining type information, and printing. More...

## Additional Inherited Members
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkInterpolationKernel
bool | RequiresInitialization
vtkAbstractPointLocator * | Locator
vtkDataSet * | DataSet
vtkPointData * | PointData
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

a Voronoi interpolation kernel

vtkVoronoiKernel is an interpolation kernel that simply returns the closest point to a point to be interpolated. A single weight is returned with value=1.0.

Warning
  In degenerate cases (where a point x is equidistance from more than one point) the kernel basis arbitrarily chooses one of the equidistant points.

See also
  vtkInterpolationKernel vtkGeneralizedKernel vtkProbabilisticVoronoiKernel

Tests:
  vtkVoronoiKernel (Tests)

Definition at line 33 of file vtkVoronoiKernel.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkInterpolationKernel vtkVoronoiKernel::Superclass

Standard methods for instantiation, obtaining type information, and printing.

Definition at line 41 of file vtkVoronoiKernel.h.

## Constructor & Destructor Documentation

## ◆ vtkVoronoiKernel()

vtkVoronoiKernel::vtkVoronoiKernel | ( |  | ) |
| protected

## ◆ ~vtkVoronoiKernel()

vtkVoronoiKernel::~vtkVoronoiKernel | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkVoronoiKernel* vtkVoronoiKernel::New | ( |  | ) |
| static

Standard methods for instantiation, obtaining type information, and printing.

## ◆ IsTypeOf()

static vtkTypeBool vtkVoronoiKernel::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for instantiation, obtaining type information, and printing.

## ◆ IsA()

virtual vtkTypeBool vtkVoronoiKernel::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instantiation, obtaining type information, and printing.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkVoronoiKernel* vtkVoronoiKernel::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for instantiation, obtaining type information, and printing.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkVoronoiKernel::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instantiation, obtaining type information, and printing.

## ◆ NewInstance()

vtkVoronoiKernel* vtkVoronoiKernel::NewInstance | ( |  | ) | const

Standard methods for instantiation, obtaining type information, and printing.

## ◆ PrintSelf()

void vtkVoronoiKernel::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for instantiation, obtaining type information, and printing.

Reimplemented from vtkInterpolationKernel.

## ◆ ComputeBasis()

vtkIdType vtkVoronoiKernel::ComputeBasis | ( | double | x[3],
|  | vtkIdList * | pIds,
|  | vtkIdType | ptId = `0`
| ) |  |
| overridevirtual

Given a point x (and optional associated ptId), determine the points around x which form an interpolation basis.

The user must provide the vtkIdList pIds, which will be dynamically resized as necessary. The method returns the number of points in the basis. Typically this method is called before ComputeWeights().

Implements vtkInterpolationKernel.

## ◆ ComputeWeights()

vtkIdType vtkVoronoiKernel::ComputeWeights | ( | double | x[3],
|  | vtkIdList * | pIds,
|  | vtkDoubleArray * | weights
| ) |  |
| overridevirtual

Given a point x, and a list of basis points pIds, compute interpolation weights associated with these basis points.

Note that both the nearby basis points list pIds and the weights array are provided by the caller of the method, and may be dynamically resized as necessary. Typically this method is called after ComputeBasis(), although advanced users can invoke ComputeWeights() and provide the interpolation basis points pIds directly.

Implements vtkInterpolationKernel.

The documentation for this class was generated from the following file:

- Filters/Points/vtkVoronoiKernel.h